<?xml version="1.0" encoding="ISO-8859-1"?> 

<xsl:stylesheet 
   version="1.0" 
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   xmlns="http://www.w3.org/TR/REC-html40"> 

<xsl:output method="html"/>

<!--
<img 
  file = "DSCF2602.JPG" 
  showtime = "151" 
  showtime_planned = "150" 
  showtime_planned2 = "150" 
  sleep = "0" 
  paused = "0" 
  nextPic = "0"/>
-->

<xsl:variable name="colspan" select="3"/>


<xsl:variable name="imgs" select="count(//img)"/>
<xsl:variable name="init" select="sum(/whs/imgseq/init/@showtime)"/>

<xsl:variable name="actualShowtime" select="(1000*//imgseq/end/@sec + //imgseq/end/@ms - (1000*//imgseq/start/@sec + //imgseq/start/@ms)) - $init"/>

<xsl:variable name="showtime" select="sum(//img/@showtime)"/>
<xsl:variable name="showtimePlanned" select="sum(//img/@showtime_planned)"/>
<xsl:variable name="showtimePlanned2" select="sum(//img/@showtime_planned2)"/>
<xsl:variable name="sleeped" select="sum(//img/@sleep[. > 0])"/>
<xsl:variable name="cpuLag" select="-1 * sum(//img/@sleep[. &lt; 0])"/>
<xsl:variable name="paused" select="sum(//img/@paused)"/>
<xsl:variable name="pausedCounter" select="count(//img/@paused[. > 0])"/>
<xsl:variable name="nextpicCounter" select="count(//img/@nextPic[. > 0])"/>




<xsl:template match="imgseq">
<html>
  <head>
  <title>Info about Weirdeomat Image Sequence</title>
  </head>
  
<style type="text/css">

body { background-color:#EEEEEE; font-family:'Small Fonts',sans-serif;}

td { background-color:#CCCCCC; }
th { background-color:#C4C4C4; text-align:left; font-weight:normal; }
#thh { font-weight:bold; }

.calc { background-color:#A5B6C0; text-align:center; }
.actual { background-color:#AEC2A3; text-align:center; }

.chap { font-family:Arial,sans-serif; font-size:20pt; color:blue;
      border-bottom-style:solid; border-bottom-width:3px; border-color:red;
      margin:0px; margin-bottom:16px; }
.sect { font-family:Arial,sans-serif; font-size:16pt; color:blue;
      border-bottom-style:solid; border-bottom-width:3px; border-color:red;
      margin:0px; margin-top:24px; margin-bottom:16px; }
.p  { font-family:Arial,sans-serif; font-size:11pt; color:black; margin-top:6px; margin-bottom:6px; }
.red   { color:red }
.blue  { color:blue }
.bold  { font-weight:bold }
.big   { font-size:24pt }

.distS   { 
	text-align:center;
	font-size:0pt;
	background-color:#E4E4E4; 
}
.distM   { 
	text-align:center;
	font-size:6pt;
	background-color:#DCDCDC;
}
.distL   { 
	text-align:center;
	font-size:12pt;
	background-color:#D4D4D4;
}
.distXL   { 
	text-align:center;
	font-size:18pt;
}

.important { background-color:#cF4242; }

.small { font-size:6pt; font-family:'Small Fonts',sans-serif; }
.small a:link    { color:#000000; text-decoration:none; font-weight:normal;}
.small a:hover   { color:#000000; text-decoration:underline; font-weight:normal; }
.small a:active  { color:#000000; text-decoration:underline; font-weight:normal; }
.small a:visited { color:#000000; font-weight:normal; }

a:link { color:#AD221D; text-decoration:none; font-weight:bold; }
a:visited { color:#cF4242; text-decoration:none; font-weight:bold; }
a:active { color:#AD221D; text-decoration:none; font-weight:bold; }
a:hover { color:#cF4242; text-decoration:none; font-weight:bold; }

</style> 

  <body topmargin="2">
    <div align="center">
    <!--
      <h1>Analysis of <a href="http://weirdeos.net">WHS</a> log file</h1>
      -->
      <table border="0" cellspacing="2" cellpadding="5">
      <!--
        <tr>
          <td class="dist" style="background-color:#EEEEEE; text-align:center"><xsl:attribute name="colspan"><xsl:value-of select="$colspan+1"/></xsl:attribute>              
          <span style="color:#EEEEEE">Analysis of <span style="color:#E9E9E9; font-weight:bold;">WHS</span> log file</span>
          </td>
        </tr>
        <tr>
          <td class="dist" style="background-color:#E4E4E4; text-align:center"><xsl:attribute name="colspan"><xsl:value-of select="$colspan+1"/></xsl:attribute>              
          <span style="color:#E4E4E4">Analysis of <span style="color:#DDDDDD; font-weight:bold;">WHS</span> log file</span>
          </td>
        </tr>
        <tr>
          <td class="dist" style="background-color:#DCDCDC; text-align:center"><xsl:attribute name="colspan"><xsl:value-of select="$colspan+1"/></xsl:attribute>              
          <span style="color:#DCDCDC">Analysis of <span style="color:#BFBFBF; font-weight:bold;">WHS</span> log file</span>
          </td>
        </tr>
        <tr>
          <td class="dist" style="background-color:#D4D4D4; text-align:center"><xsl:attribute name="colspan"><xsl:value-of select="$colspan+1"/></xsl:attribute>              
          <span style="color:#D4D4D4">Analysis of <span style="color:#999999; font-weight:bold;">WHS</span> log file</span>
          </td>
        </tr>
        -->
        <!--
        <tr>
          <td class="dist" style="background-color:#EBEBEB; text-align:center"><xsl:attribute name="colspan"><xsl:value-of select="$colspan+1"/></xsl:attribute>              
          &#160;
          </td>
        </tr>
        -->
        <!-- intro -->
        <tr>
          <td class="distS"><xsl:attribute name="colspan"><xsl:value-of select="$colspan+1"/></xsl:attribute>              
          &#160;
          </td>
        </tr>
        <tr>
          <td class="distM"><xsl:attribute name="colspan"><xsl:value-of select="$colspan+1"/></xsl:attribute>              
          &#160;
          </td>
        </tr>
        <tr>
          <td class="distL"><xsl:attribute name="colspan"><xsl:value-of select="$colspan+1"/></xsl:attribute>              
          &#160;
          </td>
        </tr>
        <tr>
          <td class="distXL"><xsl:attribute name="colspan"><xsl:value-of select="$colspan+1"/></xsl:attribute>              
          &#160;
          </td>
        </tr>
        <tr>
          <td class="big" style="background-color:#C4C4C4; text-align:center"><xsl:attribute name="colspan"><xsl:value-of select="$colspan+1"/></xsl:attribute>              
          Analysis of <a href="http://weirdeos.net">WHS</a> log file
          </td>
        </tr>


        <!-- main -->
        <tr>
          <th>application</th>
          <td><xsl:attribute name="colspan"><xsl:value-of select="$colspan"/></xsl:attribute><xsl:value-of select="/whs/app/@name"/> &#160;<xsl:value-of select="/whs/app/@version"/></td>
        </tr>
        <tr>
          <th>directory</th>
          <td><xsl:attribute name="colspan"><xsl:value-of select="$colspan"/></xsl:attribute><xsl:value-of select="//imgseq/@basedir"/></td>
        </tr>
        <tr>
          <th>shown images </th>
          <td><xsl:attribute name="colspan"><xsl:value-of select="$colspan"/></xsl:attribute><xsl:value-of select="$imgs"/></td>
        </tr>
        <tr>
          <th>nextPic </th>
          <td><xsl:attribute name="colspan"><xsl:value-of select="$colspan"/></xsl:attribute>
            <xsl:value-of select="$nextpicCounter"/> times
          </td>
        </tr>
        <tr>
          <th>paused</th>
          <td><xsl:attribute name="colspan"><xsl:value-of select="$colspan"/></xsl:attribute>
            <xsl:value-of select="$pausedCounter"/> times
            (<xsl:value-of select="format-number($paused div 1000, '#.###')"/> s)
          </td>
        </tr>
        <tr>
          <th>start </th>
          <td class="actual" style="text-align:left;"><xsl:attribute name="colspan"><xsl:value-of select="$colspan"/></xsl:attribute><xsl:value-of select="start/@time"/></td>
        </tr>
        <tr>
          <th>end </th>
          <td class="actual" style="text-align:left"><xsl:attribute name="colspan"><xsl:value-of select="$colspan"/></xsl:attribute><xsl:value-of select="end/@time"/></td>
        </tr>
        <tr>
          <th rowspan="2">from logfile</th>
          <th colspan="2" class="calc" id="thh"> using &lt;img&gt; tags</th>
          <th rowspan="2" id="thh" class="actual">using &lt;start&gt; and &lt;end&gt; tag<br/>(end - start)</th>
        </tr>
        <tr>
          <th class="calc" id="thh">planned</th>
          <th class="calc" id="thh">actual</th>
        </tr>
        <!-- 
        <tr>
          <th>init </th>
          <td><xsl:attribute name="colspan"><xsl:value-of select="$colspan"/></xsl:attribute><xsl:value-of select="$init"/> ms</td>
        </tr>
        -->
        <tr>
          <th>duration </th>
          <td class="calc">
              <xsl:value-of select="format-number($showtimePlanned div 1000, '#.###')"/> s  &#160;
              (<xsl:value-of select="format-number(1000 * $imgs div $showtimePlanned, '#.##')"/> fps)
              <br/>
              [<xsl:value-of select="format-number($showtimePlanned2 div 1000, '#.###')"/> s  &#160;
              (<xsl:value-of select="format-number(1000 * $imgs div $showtimePlanned2, '#.##')"/> fps)]
          </td>
          <td class="calc"><xsl:value-of select="format-number($showtime div 1000, '#.###')"/> s  &#160;
              (<xsl:value-of select="format-number(1000 * $imgs div $showtime, '#.##')"/> fps)</td>
          <td class="actual"><xsl:value-of select="format-number($actualShowtime div 1000, '#.###')"/> s  &#160;
              (<xsl:value-of select="format-number(1000 * $imgs div $actualShowtime, '#.##')"/> fps)</td>
        </tr>
        <!--tr>       
          <th>difference </th>
          <td><xsl:attribute name="colspan"><xsl:value-of select="$colspan"/></xsl:attribute>&#160; <xsl:value-of select="format-number(($showtime - $calculatedDuration) div 1000, '#.###')"/> s &#160; 
              (calculated + <span class="important"><xsl:value-of select="format-number((100 div $calculatedDuration * ($showtime - $calculatedDuration)), '#.##')"/>%</span> = actual)</td>
        </tr-->
        <tr>       
          <th>correction to<br/>reach <span class="actual">duration</span></th>
          <td class="calc">&#160; + <span class="important"><xsl:value-of select="format-number((100 div $actualShowtime * ($actualShowtime - $showtimePlanned)), '#.##')"/>%</span></td>
          <td class="calc">&#160; + <span class="important"><xsl:value-of select="format-number((100 div $actualShowtime * ($actualShowtime - $showtime)), '#.##')"/>%</span></td>
          <td >&#160;</td>
        </tr>
<!--        
-->
        <tr>       
          <th rowspan="2">cpu lag</th>
          <td class="calc" style="text-align:center"><xsl:attribute name="colspan"><xsl:value-of select="$colspan"/></xsl:attribute>
            <xsl:value-of select="format-number( $cpuLag div 1000, '#.###')"/> s
          </td>
        </tr>
        <tr>       
          <td class="calc">&#160;&#160; <xsl:value-of select="format-number((100 div $showtimePlanned * $cpuLag), '#.##')"/> %</td>
          <td class="calc">&#160;&#160; <xsl:value-of select="format-number((100 div $showtime * $cpuLag), '#.##')"/> %</td>
          <td class="actual">&#160;&#160; <xsl:value-of select="format-number((100 div $actualShowtime * $cpuLag), '#.##')"/> %</td>
        </tr>
        <tr>       
          <th>average</th>
          <td class="calc">
            <xsl:value-of select="format-number( $showtimePlanned div $imgs , '#')"/> ms per frame
            <br/>
            <xsl:value-of select="format-number(1000 * $imgs div $showtimePlanned, '#.##')"/> fps
            <br/>
            <xsl:value-of select="format-number(1000 * $imgs div $showtimePlanned * 60, '#.##')"/> bpm
          </td>
          <td class="calc">
            <xsl:value-of select="format-number( $showtime div $imgs , '#')"/> ms per frame
            <br/>
            <xsl:value-of select="format-number(1000 * $imgs div $showtime, '#.##')"/> fps
            <br/>
            <xsl:value-of select="format-number(1000 * $imgs div $showtime * 60, '#.##')"/> bpm
          </td>
          <td class="actual">
            <xsl:value-of select="format-number( $actualShowtime div $imgs , '#')"/> ms per frame
            <br/>
            <xsl:value-of select="format-number(1000 * $imgs div $actualShowtime, '#.##')"/> fps
            <br/>
            <xsl:value-of select="format-number(1000 * $imgs div $actualShowtime * 60, '#.##')"/> bpm
          </td>
        </tr>
        <tr>       
          <th>sleeped</th>
          <td >&#160;</td>
          <td class="calc">&#160; <xsl:value-of select="format-number($sleeped div 1000, '#.##')"/> s<br/>
          <xsl:value-of select="format-number( $sleeped div $imgs , '#')"/> ms per frame</td>
          <td >&#160;</td>
        </tr>
<!--
-->     


        <!-- outro -->
        <tr>
          <td class="big" style="background-color:#C4C4C4; text-align:center"><xsl:attribute name="colspan"><xsl:value-of select="$colspan+1"/></xsl:attribute>
              &#160;
              <span class="small">
                This document was translated by a XSLT-Processor from <xsl:value-of select="system-property('xsl:vendor')"/> 
                (version <xsl:value-of select="system-property('xsl:version')"/>) -
                <a><xsl:attribute name="href"><xsl:value-of select="system-property('xsl:vendor-url')"/></xsl:attribute><xsl:value-of select="system-property('xsl:vendor-url')"/></a>
              </span>
          </td>
        </tr>
        <tr>
          <td class="distXL"><xsl:attribute name="colspan"><xsl:value-of select="$colspan+1"/></xsl:attribute>              
          &#160;
          </td>
        </tr>
        <tr>
          <td class="distL"><xsl:attribute name="colspan"><xsl:value-of select="$colspan+1"/></xsl:attribute>              
          &#160;
          </td>
        </tr>
        <tr>
          <td class="distM"><xsl:attribute name="colspan"><xsl:value-of select="$colspan+1"/></xsl:attribute>              
          &#160;
          </td>
        </tr>
        <tr>
          <td class="distS"><xsl:attribute name="colspan"><xsl:value-of select="$colspan+1"/></xsl:attribute>              
          &#160;
          </td>
        </tr>

      </table>
    </div>   
  </body>
</html>
</xsl:template>



<xsl:template match="img">

</xsl:template>
	

</xsl:stylesheet>